using System.Diagnostics;
using System;
using System.Windows.Forms;
using System.Collections;
using System.Drawing;
using System.Data;
using System.Collections.Generic;

namespace JRCaptureDemo
{
	public partial class Form1
	{
		public Form1()
		{
			InitializeComponent();
			
			//Added to support default instance behavour in C#
			if (defaultInstance == null)
				defaultInstance = this;
		}
		
		#region Default Instance
		
		private static Form1 defaultInstance;
		
		/// <summary>
		/// Added by the VB.Net to C# Converter to support default instance behavour in C#
		/// </summary>
		public static Form1 Default
		{
			get
			{
				if (defaultInstance == null)
				{
					defaultInstance = new Form1();
					defaultInstance.FormClosed += new FormClosedEventHandler(defaultInstance_FormClosed);
				}
				
				return defaultInstance;
			}
		}
		
		static void defaultInstance_FormClosed(object sender, FormClosedEventArgs e)
		{
			defaultInstance = null;
		}
		
		#endregion
		//This is a sample application to show all the functions of JRCapturenet.dll
		//You can reach me at my email address webmaster@jrsoft.de
		//to report any suggestion, bug report or problems
		//your facing, I can't guaranty an answer to your problem.
		//The control's web site is at:
		//http://www.jrsoft.de
		//There you will find a bunch of other Controls.
		
		
		//--------------------------------------------
		//be sure to have a reference to JRCaptureNET.dll
		//--------------------------------------------
		JRCaptureNet.Capture JRCapture = new JRCaptureNet.Capture();
		
		#region normal capture functions with or without capture the Mousepointer
		//-----------------------------------------------------------------
		public void Desktop_Click(System.Object sender, System.EventArgs e)
		{
			//capture Desktop
			//PictureBox1.Image = JRCapture.CaptureDesktop()
			//or
			JRCapture.CaptureDesktop();
			PictureBox1.Image = JRCapture.Picture;
		}
		public void ActiveWindow_Click(System.Object sender, System.EventArgs e)
		{
			//capture active Window
			PictureBox1.Image = JRCapture.CaptureWin();
		}
		public void RectangelArea_Click(System.Object sender, System.EventArgs e)
		{
			//capture rectangel area
			if (JRCapture.CaptureArea() != null)
			{
				PictureBox1.Image = JRCapture.Picture;
			}
		}
		#endregion
		
		#region advanced capture functions with or without capture the Mousepointer
		
		public void DesktopRegion_Click(System.Object sender, System.EventArgs e)
		{
			//capture a region of the Desktop
			
			//define the region to capture
			JRCapture.CaptureRegionHeight = 400;
			JRCapture.CaptureRegionLeft = 300;
			JRCapture.CaptureRegionTop = 200;
			JRCapture.CaptureRegionWidth = 400;
			
			//activate the region capture tool
			JRCapture.CaptureRegion = true;
			PictureBox1.Image = JRCapture.CaptureDesktop();
			//deactivate the region capture tool
			JRCapture.CaptureRegion = false;
		}
		public void ActiveWindowRegion_Click(System.Object sender, System.EventArgs e)
		{
			//capture a region in the active Window
			
			//define the capture Region
			JRCapture.CaptureRegionHeight = 400;
			JRCapture.CaptureRegionLeft = 300;
			JRCapture.CaptureRegionTop = 200;
			JRCapture.CaptureRegionWidth = 400;
			
			//activate the region capture tool
			JRCapture.CaptureRegion = true;
			PictureBox1.Image = JRCapture.CaptureWin();
			//deactivate the region capture tool
			JRCapture.CaptureRegion = false;
		}
		public void ByHandle_Click(System.Object sender, System.EventArgs e)
		{
			//capture a Object or Window by his handle
			PictureBox1.Image = JRCapture.CaptureByHWND((long )ToolStrip1.Handle);
		}
		public void RegionByHandle_Click(System.Object sender, System.EventArgs e)
		{
			//capture a region of an Object or Window by his handle
			
			//define the capture Region
			JRCapture.CaptureRegionHeight = 50;
			JRCapture.CaptureRegionLeft = 5;
			JRCapture.CaptureRegionTop = 5;
			JRCapture.CaptureRegionWidth = 50;
			
			//activate the region capture tool
			JRCapture.CaptureRegion = true;
			PictureBox1.Image = JRCapture.CaptureByHWND((long)ToolStrip1.Handle);
			//deactivate the region capture tool
			JRCapture.CaptureRegion = false;
			
		}
		public void RegionByHandleXTimes_Click(System.Object sender, System.EventArgs e)
		{
			long n;
			//capture a region of a Object or Window by his handle x times
			//define the capture Region
			JRCapture.CaptureRegionLeft = 10;
			JRCapture.CaptureRegionTop = 0;
			JRCapture.CaptureRegionWidth = 100;
			JRCapture.CaptureRegionHeight = 50;
			
			//activate the region capture tool
			JRCapture.CaptureRegion = true;
			
			//set fast shooting
			JRCapture.CaptureDelayMs = 20; //yes you can go down to 0
			JRCapture.PlaySound = false;
			
			//capture x times
			for (n = 1; n <= 100; n++)
			{
				//only for fun we scroll the capture region
				JRCapture.CaptureRegionLeft = JRCapture.CaptureRegionLeft + 5;
				PictureBox1.Image = JRCapture.CaptureByHWND((long)ToolStrip1.Handle);
				PictureBox1.Refresh();
			}
			//deactivate the region capture tool
			JRCapture.CaptureRegion = false;
			
			//back to the old settings
			JRCapture.PlaySound = CheckBox1.Checked;
			JRCapture.CaptureDelayMs =  Int64.Parse (TextBox1.Text);
			
		}
		public void DesktopRegionXTimes_Click(System.Object sender, System.EventArgs e)
		{
			long n;
			//capture a region of the desktop x times
			//define the capture Region
			JRCapture.CaptureRegionLeft = 10;
			JRCapture.CaptureRegionTop = 20;
			JRCapture.CaptureRegionWidth = 200;
			JRCapture.CaptureRegionHeight = 250;
			
			//activate the region capture tool
			JRCapture.CaptureRegion = true;
			
			//set fast shooting
			JRCapture.CaptureDelayMs = 0;
			JRCapture.PlaySound = false;
			
			for (n = 1; n <= 100; n++)
			{
				//only for fun we scroll the capture region
				JRCapture.CaptureRegionLeft = JRCapture.CaptureRegionLeft + 2;
				JRCapture.CaptureRegionTop = JRCapture.CaptureRegionTop + 2;
				PictureBox1.Image = JRCapture.CaptureDesktop();
				PictureBox1.Refresh();
			}
			//deactivate the region capture tool
			
			JRCapture.CaptureRegion = false;
			
			//back to the old settings
			JRCapture.PlaySound = CheckBox1.Checked;
			JRCapture.CaptureDelayMs =  Int64.Parse (TextBox1.Text);
			
		}
		#endregion
		
		#region save the captured image to file
		//-------------------------------------------------------
		public void SaveAsBMP_Click(System.Object sender, System.EventArgs e)
		{
			string picPath;
			picPath = Application.StartupPath;
			// ggf. abschließenden Backslash hinzufügen
			if (! picPath.EndsWith("\\"))
			{
				picPath = picPath + "\\";
			}
			JRCapture.Save(picPath + "test.bmp");
		}
		public void SaveAsPNG_Click(System.Object sender, System.EventArgs e)
		{
			string picPath;
			picPath = Application.StartupPath;
			// ggf. abschließenden Backslash hinzufügen
			if (! picPath.EndsWith("\\"))
			{
				picPath = picPath + "\\";
			}
			JRCapture.Save(picPath + "test.png");
			
		}
		#endregion
		
		#region settings for the capture control
		public void CheckBox1_CheckedChanged(System.Object sender, System.EventArgs e)
		{
			JRCapture.PlaySound = CheckBox1.Checked;
		}
		public void CheckBox2_CheckedChanged(System.Object sender, System.EventArgs e)
		{
			JRCapture.CaptureOnlyClientArea = CheckBox2.Checked;
		}
		public void CheckBox3_CheckedChanged(System.Object sender, System.EventArgs e)
		{
			JRCapture.CaptureMouseCursor = CheckBox3.Checked;
		}
		public void TextBox1_TextChanged(System.Object sender, System.EventArgs e)
		{
			JRCapture.CaptureDelayMs =  Int64.Parse (TextBox1.Text);
		}
		public void CheckBox4_CheckedChanged(System.Object sender, System.EventArgs e)
		{
			JRCapture.CopyToClipboard = CheckBox4.Checked;
		}
		#endregion
		
		#region form and menue handling
		
		public void Form1_Load(object sender, System.EventArgs e)
		{
			TextBox1.Text = "1000";
			CheckBox1.Checked = JRCapture.PlaySound;
			
			CheckBox2.Checked = JRCapture.CaptureOnlyClientArea;
			CheckBox3.Checked = JRCapture.CaptureMouseCursor;
			
			
			CheckBox4.Checked = JRCapture.CopyToClipboard;
			
			//you are a software developer
			//please order your serialnumber and regcode at www.jrsoft.de
			JRCapture.SerialNumber = 0;
			JRCapture.RegCode = 0;
			
			
			if (JRCapture.IsDemoVersion)
			{
				this.Text = "JRCapture .Net dll V" + JRCapture.Version + " demo for software developers to test all functions";
			}
			else
			{
				this.Text = "JRCapture .Net dll V" + JRCapture.Version + " this is a sample program for software developers to test all the functions.";
			}
		}
		public void CaptureDesktop_Click(System.Object sender, System.EventArgs e)
		{
			Desktop_Click(sender, e);
		}
		public void CaptureActiveWindow_Click(System.Object sender, System.EventArgs e)
		{
			ActiveWindow_Click(sender, e);
		}
		public void CaptureRectangelArea_Click(System.Object sender, System.EventArgs e)
		{
			RectangelArea_Click(sender, e);
		}
		public void ExitToolStripMenuItem_Click(System.Object sender, System.EventArgs e)
		{
			Application.Exit();
		}
		#endregion
		
		
	}
	
}
